VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPyApi"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'low level python api access
'note bad args can easily crash your process...(including IDE!)

'there are like anothet 500 some api available to us already wrapped as stdcall stubs in py4vb.dll
'will write and test the declares as I need them..probably dont need most.
'see ./../_py_api_wrap/final_exports.txt for the prototypes

Enum opPy
    op_Init = 0
    op_Final = 1
    op_LoadCode = 2
    op_GetFunc = 3
    op_NewTuple = 4
    op_CreateLong = 5
    op_GetLong = 7
    op_GetAttrStr = 12
    op_AddIntConst = 13
    op_ImportMod = 14
    op_interrupt = 15
    op_decref = 16
    op_incref = 17
    op_refcnt = 18
    op_AddObj = 19
    op_TypeName = 20
    op_HasLen = 21
    op_NewStr = 22
    op_GetMod = 23
    op_eval = 24
    op_LoadFile = 25
End Enum

Function op(p As opPy, Optional arg1 As Long = 0, Optional arg2 As String = "", Optional arg3 As Long = 0) As Long
    op = PyOp(p, arg1, arg2, arg3)
End Function

Function GetAttr(ByVal name As String, Optional pObj As Long = 0) As CPythonObj
    Dim po As New CPythonObj 'this is a weak reference i believe
    po.hObj = PyOp(op_GetAttrStr, pObj, name) 'by default gets a global obj, unless p(arent)Obj is set
    If pObj <> 0 Then po.name = Hex(pObj) & "." & name Else po.name = name
    'po.strongRef = True
    Set GetAttr = po
End Function

Function PyCheck(ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long
    PyCheck = py4VB.PyCheck(operation, arg1)
End Function

Public Function PySize(ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long
    PySize = py4VB.PySize(operation, arg1)
End Function

Function SetArgv(args() As String) As Long  'must be string array passing as variant to prevent ascii conversion.
    SetArgv = py4VB.SetArgv(args)
End Function

'int __stdcall SetItem(PyObject* pArgs, int sz, PyObject* pVal) {
Function SetItem(ByVal pArgs As Long, Optional ByVal sz As Long, Optional ByVal pVal As Long) As Long
    SetItem = py4VB.SetItem(pArgs, sz, pVal)
End Function

'PyObject* __stdcall CallObject(PyObject* pFunc, PyObject* pArgs) {
Function CallObject(ByVal pFunc As Long, ByVal pArgs As Long) As Long
    CallObject = py4VB.CallObject(pFunc, pArgs)
End Function

'VARIANT* __stdcall GetStr(PyObject* po)'this def vb puts an Variant* on stack and wacks first arg in C
'int __stdcall GetStr(PyObject* po, VARIANT* v)
Function GetStr(ByVal pyObj As Long, ByRef v As Variant) As Long
    GetStr = py4VB.GetStr(pyObj, v)
End Function

'handle to a python object auto convert to vb type, even arrays (not dicts)
Function ObjToVariant(ByVal pyObj As Long, ByRef v As Variant) As Long
    ObjToVariant = py4VB.ObjToVariant(pyObj, v)
End Function

'take a vb type and convert it to a python object handle
Function VariantToPyObj(ByRef v As Variant) As Long
    VariantToPyObj = py4VB.VariantToPyObj(v)
End Function

Function decref(mObj As Long) As Long
    decref = PyOp(op_decref, mObj) 'returns refcnt
End Function

Function incref(mObj As Long) As Long
    incref = PyOp(op_incref, mObj) 'returns refcnt
End Function

Function refcnt(mObj As Long) As Long
    refcnt = PyOp(op_refcnt, mObj)
End Function

Function getType(mObj As Long) As pyTypes
    If PyCheck(pt_String, mObj) = 1 Then getType = pt_String
    If PyCheck(pt_Long, mObj) = 1 Then getType = pt_Long
    If PyCheck(pt_Bool, mObj) = 1 Then getType = pt_Bool
    If PyCheck(pt_List, mObj) = 1 Then getType = pt_List
    If PyCheck(pt_Tuple, mObj) = 1 Then getType = pt_Tuple
    If PyCheck(pt_Float, mObj) = 1 Then getType = pt_Float
    If PyCheck(pt_Dict, mObj) = 1 Then getType = pt_Dict
    If PyCheck(pt_Complex, mObj) = 1 Then getType = pt_Complex
    If PyCheck(pt_Bytes, mObj) = 1 Then getType = pt_Bytes
    If PyCheck(pt_ByteAry, mObj) = 1 Then getType = pt_ByteAry
    If PyCheck(pt_None, mObj) = 1 Then getType = pt_None
    If PyCheck(pt_set, mObj) = 1 Then getType = pt_set
End Function

Function getValue(mObj As Long, Optional t As pyTypes = -2) As Variant

    Dim v As Variant, rv As Long, rc As Long

    If t = -2 Then t = getType(mObj)

    If t = pt_Dict Or t = pt_Complex Or t = pt_set Or t = pt_unknown Then
        rv = GetStr(mObj, v)
        If rv = 1 Then
            'Debug.Print "getValue.GetStr = " & rv & " type=" & TypeName(v)
            getValue = v
        End If
        Exit Function
    End If

    rv = ObjToVariant(mObj, v)
    If rv = 1 Then getValue = v

End Function



Function typeForName(globalName As String, Optional ByRef obj As Long) As pyTypes

    obj = PyOp(op_GetAttrStr, , globalName)
    
    If obj = -1 Then
        typeForName = pt_notFound
        Exit Function
    End If
    
    If obj = 0 Or obj = -1 Then Exit Function
    
    typeForName = getType(obj)
    
End Function
