VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPythonObj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Enum pyTypes
    pt_notFound = -1
    pt_unknown = 0
    pt_String = 1
    pt_Bool = 2
    pt_List = 3
    pt_Long = 4
    pt_Tuple = 5
    pt_Float = 6
    pt_Dict = 7
    pt_Complex = 8
    pt_Bytes = 9
    pt_ByteAry = 10
    pt_None = 11
    pt_isTrue = 12
    pt_set = 13
End Enum

Public name As String 'for debugging refs...
Private mObj As Long
Private mType As pyTypes
'Public strongRef As Boolean

Property Get pyType() As pyTypes
    pyType = mType
End Property

Property Get isZero() As Boolean
    If mObj = 0 Or mObj = -1 Then
        isZero = True
    Else
        isZero = False
    End If
End Property

Property Get hObj() As Long
    hObj = mObj
End Property

Property Let hObj(h As Long)
    Dim r As Long
    'If mObj <> 0 And strongRef Then
    '    r = decref
    '    If r <> 0 Then Debug.Print "Released " & Hex(mObj); " but refcnt is still = " & r
    'End If
    mObj = h
    mType = getType()
End Property

Function attach(h As Long) ', Optional isStrongRef As Boolean = False)
    hObj = h
    'strongRef = isStrongRef
    'If strongRef Then incref
End Function

Function release()
    hObj = 0
    'strongRef = False
End Function

Property Get refCnt() As Long
    refCnt = PyOp(op_refcnt, mObj)
End Property

Function incref() As Long
    incref = PyOp(op_incref, mObj) 'returns refcnt
End Function

Function decref() As Long
    decref = PyOp(op_decref, mObj) 'returns refcnt
    If Len(name) > 0 Then Debug.Print name & ":" & decref
End Function

Function getTypeName() As String
    Dim p As Long
    p = PyOp(op_TypeName, mObj)
    If p <> 0 And p <> -1 Then
        getTypeName = StringFromPointer(p)
    End If
End Function

Function CallMethod(ParamArray args()) As CPythonObj
    Dim ret As New CPythonObj
    
    If UBound(args) <> -1 Then
        MsgBox "todo handle args (create tuple of CPythonObjs from vb types)"
    End If
    
    ret.hObj = CallObject(mObj, 0)
    Set CallMethod = ret

End Function


Function getChildAttr(attrName As String) As CPythonObj
    Dim py As New CPythonObj
    py.hObj = PyOp(op_GetAttrStr, mObj, attrName)
    py.name = Me.name & "." & attrName
    'strongRef = True
    Set getChildAttr = py
End Function

'complex and dict fail
Function getValue() As Variant

    Dim v As Variant, rv As Long, rc As Long, t As pyTypes

    t = mType
    
    If t = pt_Dict Or t = pt_Complex Or t = pt_set Or t = pt_unknown Then
        rv = GetStr(mObj, v)
        If rv = 1 Then
            'Debug.Print "getValue.GetStr = " & rv & " type=" & TypeName(v)
            getValue = v
        End If
        Exit Function
    End If
    
    'rc = PyOp(op_refcnt, obj)
    'Debug.Print "refcnt: " & rc
    
    rv = ObjToVariant(mObj, v)
    If rv = 1 Then getValue = v

    
End Function

Private Function getType() As pyTypes
    If PyCheck(pt_String, mObj) = 1 Then getType = pt_String
    If PyCheck(pt_Long, mObj) = 1 Then getType = pt_Long
    If PyCheck(pt_Bool, mObj) = 1 Then getType = pt_Bool
    If PyCheck(pt_List, mObj) = 1 Then getType = pt_List
    If PyCheck(pt_Tuple, mObj) = 1 Then getType = pt_Tuple
    If PyCheck(pt_Float, mObj) = 1 Then getType = pt_Float
    If PyCheck(pt_Dict, mObj) = 1 Then getType = pt_Dict
    If PyCheck(pt_Complex, mObj) = 1 Then getType = pt_Complex
    If PyCheck(pt_Bytes, mObj) = 1 Then getType = pt_Bytes
    If PyCheck(pt_ByteAry, mObj) = 1 Then getType = pt_ByteAry
    If PyCheck(pt_None, mObj) = 1 Then getType = pt_None
    If PyCheck(pt_set, mObj) = 1 Then getType = pt_set
End Function

Function typeToStr() As String

    Select Case mType
        Case pt_String: typeToStr = "String"
        Case pt_Long: typeToStr = "Long"
        Case pt_Bool: typeToStr = "Bool"
        Case pt_List: typeToStr = "List"
        Case pt_Tuple: typeToStr = "Tuple"
        Case pt_Float: typeToStr = "Float"
        Case pt_Dict: typeToStr = "Dict"
        Case pt_Complex: typeToStr = "Complex"
        Case pt_Bytes: typeToStr = "Bytes"
        Case pt_ByteAry: typeToStr = "ByteArray"
        Case pt_notFound: typeToStr = "Not Found"
        Case pt_None: typeToStr = "None"
        Case pt_set: typeToStr = "Set"
        Case Else: typeToStr = "Unknown"
    End Select
    
End Function


