VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Python Embedding Example"
   ClientHeight    =   10830
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9990
   LinkTopic       =   "frmMain"
   ScaleHeight     =   10830
   ScaleWidth      =   9990
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdFile 
      Caption         =   "File"
      Height          =   330
      Left            =   6480
      TabIndex        =   9
      Top             =   6660
      Width           =   555
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   285
      Left            =   3960
      TabIndex        =   8
      Top             =   6570
      Width           =   735
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Debugger UI"
      Height          =   330
      Left            =   4995
      TabIndex        =   7
      Top             =   6615
      Width           =   1320
   End
   Begin VB.CommandButton cmdAbort 
      Caption         =   "Abort"
      Height          =   375
      Left            =   7200
      TabIndex        =   6
      Top             =   6615
      Width           =   1005
   End
   Begin VB.TextBox txtRet 
      Height          =   285
      Left            =   1260
      TabIndex        =   4
      Top             =   6615
      Width           =   1815
   End
   Begin VB.TextBox txtOut 
      Height          =   3570
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   6975
      Width           =   4380
   End
   Begin VB.ListBox List1 
      Height          =   3375
      Left            =   4545
      TabIndex        =   2
      Top             =   7065
      Width           =   5190
   End
   Begin VB.CommandButton cmdExecPy 
      Caption         =   "Execute Python"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8370
      TabIndex        =   1
      Top             =   6615
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6135
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "frmMain.frx":0000
      Top             =   360
      Width           =   9690
   End
   Begin VB.Label Label3 
      Caption         =   "Return"
      Height          =   285
      Left            =   180
      TabIndex        =   5
      Top             =   6615
      Width           =   915
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents python As CPython
Attribute python.VB_VarHelpID = -1

Dim last As String

Private Sub cmdAbort_Click()
    python.Abort
End Sub

Private Sub cmdAbout_Click()
    python.ShowAbout
End Sub

Private Sub cmdFile_Click()

    'this will load a file to test local imports

    Dim base As String
    base = App.path & "\..\_file_import_test\"
    txtOut.text = Empty
    
    With python
        .Reset
        .Initilize
    
        la "AddFile(a.py) = " & .AddFile(base & "\a.py")
        la "AddFile(c.py) = " & .AddFile(base & "\c.py")
        
        'we can also execute compiled scripts
        'https://docs.python.org/3/library/py_compile.html
        ' py_compile.compile(file, cfile=None, dfile=None, doraise=False, optimize=- 1, invalidation_mode=PycInvalidationMode.TIMESTAMP, quiet=0)
        
        '   python -m py_compile script.py  -or- python -m compileall ./

        la "AddFile(c.cpython-311.pyc) = " & .AddFile(base & "\c.cpython-311.pyc")
        
        .Finalize
    End With
        
End Sub

Private Sub Command1_Click()
    Form1.show
End Sub


Function hi(x, y As Double)
    MsgBox x & " . " & y
End Function


Private Sub python_DebugHandler(ByVal t As dcb_type, msg As String)
    la "dbgmsg: " & t & ": " & msg 'shouldnt trigger in this example...
    Stop
End Sub

Private Sub python_devmsg(m As String)
    la "Msg: " & m
End Sub

Private Sub python_ScriptError(msg As String)
    la "Error: " & msg
End Sub

Private Sub python_ScriptOut(msg As String)
    txtOut = txtOut & msg
End Sub

Private Sub python_TimeOut(Cancel As Boolean)
    Dim m As VbMsgBoxResult
    
    m = MsgBox(Replace("Do you want script to timeout?\n\nYes to Stop\nNo to continue\nCancel to disable check", "\n", vbCrLf), vbYesNoCancel)
    
    If m = vbCancel Then
        python.SetTimeOut 0
    ElseIf m = vbYes Then
        Cancel = True
    ElseIf m = vbNo Then
        'let timer keep running and ask again next time around..
    End If
    
End Sub
 
Private Sub cmdExecPy_Click()

    Dim rv As Long
    Dim t As CPythonObj, x As CPythonObj, z As CPythonObj, ret As CPythonObj
    
    On Error Resume Next
    WriteFile last, Text1.text
    
    List1.Clear
    txtOut = Empty
    
    
    With python
        .Reset
        If Not .Initilize Then Exit Sub
        .SetTimeOut 8
        
        'must do after initilize...
        .AddObject App, "app"
        .AddObject Me, "frmMain"
        
        .AddCode Text1.text
        
        'easy way
        .AddCode "frmMain.txtRet.Text = str(t.x) + ' hi from vb!'"
        .AddCode "print(str(t.z()))"
        '.Eval "endless_loop()" 'test timeout
        
        Dim tmp(), v
        'eval can directly return a vb type, or a CPythonObj instance for low level access.
        tmp = .Eval("[1+2,2,'a', b'test']") 'array containing 3,2,'a', byte array("test")
        For Each v In tmp
            If IsArray(v) Then
                Debug.Print TypeName(v)
            Else
                Debug.Print v
            End If
        Next
        
        'hard way (more control)
        'honestly you probably dont need this, we have already lived with the ms script control for decades..
        'but it will have advanced uses such as extracting python lists to vb native arrays etc...
        
        Set t = python.api.GetAttr("t")  'class t from global context
        
        If Not t.isZero Then
            Set x = t.getChildAttr("x")
            If Not x.isZero Then
                la "t.x = " & x.getValue()
                x.decref
            End If
    
            Set z = t.getChildAttr("z")  'function reference
            If Not z.isZero Then
                Set ret = z.CallMethod()
                If Not ret.isZero Then 'its a list, getValue will return a vb array..
                    la "t.z returned a " & ret.typeToStr & " = " & Join(ret.getValue(), ",")
                    ret.decref
                End If
                z.decref
            End If
    
            t.decref
        End If
        
        
        .Finalize
    End With
    
    la "Complete"
    
End Sub
 
Private Sub Form_Load()
 
    last = App.path & "\last.py"
    If FileExists(last) Then Text1 = ReadFile(last)
     
    Set python = New CPython
    python.InitPython
        
    cmdExecPy.Enabled = True
 
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    WriteFile last, Text1.text
    python.ReleaseTimer 'must be done manually class_terminate will never hit if it was used...
    Set python = Nothing
End Sub

Function la(x)
    On Error Resume Next
    List1.AddItem x
    List1.ListIndex = List1.ListCount - 1
End Function

