Attribute VB_Name = "m_py4VB"
Option Explicit

'Author:  David Zimmer <dzzie@yahoo.com>
'Site:    http://sandsprite.com

Public ActiveObject As IPythonScript 'may be nothing see notes in cls file

Public hPyLib As Long
Public timeoutEnabled As Boolean

'I will deal with the /MD shared runtime requirement for now even though subtle and delicate...
'Public runFileEnabled As Boolean
'Public Declare Function PyRun_SimpleFilePath Lib "python311.dll" Alias "_PyRun_SimpleFilePath@4" (ByVal filePath As String) As Long

Public Declare Sub SetCallBacks Lib "py4VB.dll" ( _
    ByVal msgProc As Long, _
    Optional ByVal dbgCmdProc As Long = 0, _
    Optional ByVal hostResolverProc As Long = 0, _
    Optional ByVal lineInputfunc As Long = 0, _
    Optional ByVal dbgWrite As Long = 0)
    
'requires a specially built python dll, we will test for it before using..
Private Declare Sub SetTimeoutCallBack Lib "python311.dll" Alias "_SetTimeoutCallBack@4" (ByVal TimeoutProc As Long)
Private Declare Sub SetGlobalAbort Lib "python311.dll" Alias "_SetGlobalAbort@4" (ByVal gAbort As Long)

Public Declare Function About_py4vb Lib "py4VB.dll" () As Variant

Public Declare Function PyOp Lib "py4VB.dll" (ByVal operation As opPy, Optional ByVal arg1 As Long, Optional ByVal sArg As String, Optional ByVal arg3 As Long) As Long
Public Declare Function PyCheck Lib "py4VB.dll" (ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long
Public Declare Function PySize Lib "py4VB.dll" (ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long

Public Declare Function SetArgv Lib "py4VB.dll" (args As Variant) As Long 'must be string array passing as variant to prevent ascii conversion.

'int __stdcall SetItem(PyObject* pArgs, int sz, PyObject* pVal) {
Public Declare Function SetItem Lib "py4VB.dll" (ByVal pArgs As Long, Optional ByVal sz As Long, Optional ByVal pVal As Long) As Long

'PyObject* __stdcall CallObject(PyObject* pFunc, PyObject* pArgs) {
Public Declare Function CallObject Lib "py4VB.dll" (ByVal pFunc As Long, ByVal pArgs As Long) As Long

'VARIANT* __stdcall GetStr(PyObject* po)'this def vb puts an Variant* on stack and wacks first arg in C
'int __stdcall GetStr(PyObject* po, VARIANT* v)
Public Declare Function GetStr Lib "py4VB.dll" (ByVal pyObj As Long, ByRef v As Variant) As Long

'handle to a python object auto convert to vb type, even arrays (not dicts)
Public Declare Function ObjToVariant Lib "py4VB.dll" (ByVal pyObj As Long, ByRef v As Variant) As Long

'take a vb type and convert it to a python object handle
Public Declare Function VariantToPyObj Lib "py4VB.dll" (ByRef v As Variant) As Long

'misc windows api..
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, Source As Any, ByVal length As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" (ByVal lpString As Long) As Long
Public Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long



Public LastStringReturn As String
Private ABORT_SCRIPT As Boolean

Function decref(mObj As Long) As Long
    decref = PyOp(op_decref, mObj) 'returns refcnt
End Function

Function getType(mObj As Long) As pyTypes
    If PyCheck(pt_String, mObj) = 1 Then getType = pt_String
    If PyCheck(pt_Long, mObj) = 1 Then getType = pt_Long
    If PyCheck(pt_Bool, mObj) = 1 Then getType = pt_Bool
    If PyCheck(pt_List, mObj) = 1 Then getType = pt_List
    If PyCheck(pt_Tuple, mObj) = 1 Then getType = pt_Tuple
    If PyCheck(pt_Float, mObj) = 1 Then getType = pt_Float
    If PyCheck(pt_Dict, mObj) = 1 Then getType = pt_Dict
    If PyCheck(pt_Complex, mObj) = 1 Then getType = pt_Complex
    If PyCheck(pt_Bytes, mObj) = 1 Then getType = pt_Bytes
    If PyCheck(pt_ByteAry, mObj) = 1 Then getType = pt_ByteAry
    If PyCheck(pt_None, mObj) = 1 Then getType = pt_None
    If PyCheck(pt_set, mObj) = 1 Then getType = pt_set
End Function

Function getValue(mObj As Long, Optional t As pyTypes = -2) As Variant

    Dim v As Variant, rv As Long, rc As Long

    If t = -2 Then t = getType(mObj)

    If t = pt_Dict Or t = pt_Complex Or t = pt_set Or t = pt_unknown Then
        rv = GetStr(mObj, v)
        If rv = 1 Then
            'Debug.Print "getValue.GetStr = " & rv & " type=" & TypeName(v)
            getValue = v
        End If
        Exit Function
    End If

    rv = ObjToVariant(mObj, v)
    If rv = 1 Then getValue = v

End Function



Function typeForName(globalName As String, Optional ByRef obj As Long) As pyTypes

    obj = PyOp(op_GetAttrStr, , globalName)
    
    If obj = -1 Then
        typeForName = pt_notFound
        Exit Function
    End If
    
    If obj = 0 Or obj = -1 Then Exit Function
    
    typeForName = getType(obj)
    
End Function

Function scanPathFor32bitPythonInstall(ByRef pyHome As String) As Boolean
    Dim p, pp() As String, dll As String
    
    pyHome = Empty
    
    'first look for a local copy
    dll = App.path & "\python311.dll"
    If Not FileExists(dll) Then dll = GetParentFolder(App.path) & "\python311.dll"
    
    If FileExists(dll) And is32Bit(dll) Then
        pyHome = dll
        scanPathFor32bitPythonInstall = True
        Exit Function
    End If
    
    p = Environ("path")
    pp = Split(p, ";")
    
    For Each p In pp
        dll = p & "\python311.dll"
        If FileExists(dll) Then
            If is32Bit(dll) Then
                pyHome = dll
                scanPathFor32bitPythonInstall = True
                Exit Function
            End If
        End If
    Next
    
End Function

Function is32Bit(ByVal exe As String) As Boolean
    
    Dim f As Long, i As Integer
    Dim stamp As Long, e_lfanew As Long
    Dim base As Date, compiled As Date
    Dim machine As Integer
    
    Const mt_I386 = &H14C
    Const mt_IA64 = &H200

    On Error GoTo errExit
        
    FileLen exe 'throw error if not exist
    
    f = FreeFile
    Open exe For Binary Access Read As f
    Get f, , i
    
    If i <> &H5A4D Then GoTo errExit 'MZ check
     
    Get f, 60 + 1, e_lfanew
    Get f, e_lfanew + 1, i
    
    If i <> &H4550 Then GoTo errExit 'PE check (IMAGE_NT_HEADERS)
    
'    Public Type IMAGE_NT_HEADERS
'        Signature As String * 4
'        'FileHeader As IMAGE_FILE_HEADER
'            Machine As Integer
'            NumberOfSections As Integer
'            TimeDateStamp As Long

'    Get f, e_lfanew + 9, stamp
    
    Get f, e_lfanew + 5, machine
    Close f
    
    If machine = mt_I386 Then
        is32Bit = True
    ElseIf machine <> mt_IA64 Then
        Debug.Print "Unknown machine: " & Hex(machine)
    End If
        
'    base = DateSerial(1970, 1, 1)
'    compiled = DateAdd("s", stamp, base)
'    GetCompileTime = Format(compiled, "ddd, mmm d yyyy, h:nn:ss ")
    
    Exit Function
    
errExit:
    On Error Resume Next
    Close f
        
End Function


Public Function cb_TimeoutHandler(ByVal t As Long, ByVal lpMsg As Long) As Long
    'return 1 to halt execution, 0 to continue
    
    DoEvents 'allow our timer and UI to breath in case its a dead loop
    
    If ABORT_SCRIPT Then
        cb_TimeoutHandler = 1
    Else
        cb_TimeoutHandler = 0
    End If
    
End Function

Function AbortScript(Optional Abort As Boolean = True) As Boolean

    If Not timeoutEnabled Then
       If Abort Then PyOp op_interrupt
       Exit Function
    End If
    
    ABORT_SCRIPT = Abort
    SetGlobalAbort IIf(Abort, 1, 0)
    AbortScript = True
    
End Function

Function UseTimeoutHandler() As Boolean
    
    Dim p As Long
    
    'p = GetProcAddress(GetModuleHandle("python311.dll"), "_PyRun_SimpleFilePath@4")
    'If p <> 0 Then runFileEnabled = True
    
    p = GetProcAddress(GetModuleHandle("python311.dll"), "_SetTimeoutCallBack@4")
    If p = 0 Then Exit Function
    
    SetTimeoutCallBack AddressOf cb_TimeoutHandler
    SetGlobalAbort 0
    UseTimeoutHandler = True
    timeoutEnabled = True
    
End Function

Function LoadPyLib(Optional ByVal explicitPathToDll As String) As Boolean
    
    If Len(explicitPathToDll) = 0 Then
        explicitPathToDll = App.path
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = GetParentFolder(explicitPathToDll)
            If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
                explicitPathToDll = GetParentFolder(explicitPathToDll)
                If Not FileExists(explicitPathToDll & "\py4vb.dll") Then explicitPathToDll = GetParentFolder(explicitPathToDll)
            End If
        End If
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = Empty
        Else
            explicitPathToDll = explicitPathToDll & "\py4vb.dll"
        End If
    End If

    If FileExists(explicitPathToDll) Then
        hPyLib = LoadLibrary(explicitPathToDll) 'to ensure the ide finds the dll
        If hPyLib = 0 Then Exit Function
    End If
    
    'this can still work..but now its up to the runtime to find the dll..if not the app will terminate
    SetCallBacks AddressOf vb_stdout, AddressOf cb_dbgOut, AddressOf HostResolver

    If UseTimeoutHandler Then
        If Not ActiveObject Is Nothing Then
            ActiveObject.vbOut cb_devMsg, "Abort and Timeout handler available"
        End If
    End If
    
    LoadPyLib = True
    
End Function

'we actually dont use the return value in
Public Function cb_dbgOut(ByVal t As dcb_type, ByVal lpMsg As Long) As Long
    Dim msg As String
    If ActiveObject Is Nothing Then Exit Function
    If lpMsg <> 0 Then msg = StringFromPointer(lpMsg)
    cb_dbgOut = ActiveObject.DebugHandler(t, msg)
End Function

'this is used for script to host app object integration..
Public Function HostResolver(ByVal buf As Long, ByVal v1 As Long, ByVal v2 As Long, ByVal v3 As Long) As Long
    
    On Error Resume Next
    
    Dim key As String, o As Object

    If ActiveObject Is Nothing Then Exit Function
    
    key = LCase(StringFromPointer(buf))
    Set o = ActiveObject.SharedObjects(key)
    If Not o Is Nothing Then HostResolver = ObjPtr(o)
   
End Function
    
    
Function GetLastString() As String
'    Dim rv As Long
'    rv = DukOp(opd_LastString)
'    If rv = 0 Then Exit Function
'    GetLastString = StringFromPointer(rv)
End Function



Function GetArgAsString(ctx As Long, index As Long) As String
    
'    'an invalid index here would trigger a script error and aborting the eval call..weird.. <---
'    'as long as the native function is added with expected arg count, and you dont surpass it your ok
'    'even if the js function ommitted args in its call, empty ones will just be retrieved as 'undefined'
'
'    Dim ptr As Long
'    ptr = DukOp(opd_GetString, ctx, index)
'
'    If ptr <> 0 Then
'        GetArgAsString = StringFromPointer(ptr)
'    End If
    
End Function
 




'callback functions
'------------------------------
Public Sub vb_stdout(ByVal t As cb_type, ByVal lpMsg As Long)

    Dim msg As String
    
    If t = cb_Refresh Then
        DoEvents
        Sleep 3
        Exit Sub
    End If

    If lpMsg = 0 Then Exit Sub
    
    msg = StringFromPointer(lpMsg)
    
    If t = cb_StringReturn Then
        LastStringReturn = msg 'should be unused so far
        Exit Sub
    End If
                
    If ActiveObject Is Nothing Then
        Debug.Print "vb_stdout ActiveObject Is Nothing??"
        Exit Sub
    End If
    
    'If t = cb_error Then Stop 'parse errors are being printed to stdOut not stdErr...
    ActiveObject.vbOut t, UnixToDos(msg)
    
End Sub

Function UnixToDos(ByVal msg As String) As String
    Dim tmp As String
    tmp = Replace(msg, vbCrLf, Chr(5))
    tmp = Replace(tmp, vbLf, Chr(5))
    tmp = Replace(tmp, vbCr, Chr(5))
    UnixToDos = Replace(tmp, Chr(5), vbCrLf)
End Function

Public Function VbLineInput(ByVal buf As Long, ByVal ctx As Long) As Long
'    Dim b() As Byte
'    Dim retVal As String
'    VbLineInput = 0 'return value default..
'
'    Dim text As String
'    Dim def As String
'
'    text = StringFromPointer(buf)
'    def = GetArgAsString(ctx, 1)
'
'    retVal = InputBox(text, "Script Basic Line Input", def)
'
'    If Len(retVal) = 0 Then
'        DukOp opd_PushUndef, ctx
'        Exit Function
'    Else
'        DukOp opd_PushStr, ctx, 0, retVal
'    End If
        
  
End Function

Function StringFromPointer(buf As Long) As String
    Dim sz As Long
    Dim tmp As String
    Dim b() As Byte
    
    If buf = 0 Then Exit Function
       
    sz = lstrlen(buf)
    If sz = 0 Then Exit Function
    
    ReDim b(sz)
    CopyMemory b(0), ByVal buf, sz
    tmp = StrConv(b, vbUnicode)
    If Right(tmp, 1) = Chr(0) Then tmp = Left(tmp, Len(tmp) - 1)
    
    StringFromPointer = tmp
 
End Function

Sub dbg(prefix As String, ParamArray args())
    Dim a, tmp As String
    
    tmp = prefix
    
    For Each a In args
        If IsNumeric(a) Then
            tmp = tmp & Hex(a) & ", "
        ElseIf IsObject(a) Then
            tmp = tmp & "Obj: " & TypeName(a) & ", "
        Else
            tmp = tmp & a & ", "
        End If
    Next
    
    If ActiveObject Is Nothing Then
        Debug.Print tmp
    Else
        ActiveObject.vbOut cb_devMsg, tmp
    End If
    
End Sub

Function GetParentFolder(path) As String
    On Error Resume Next
    Dim tmp() As String, ub
    If Len(path) = 0 Then Exit Function
    tmp = Split(path, "\")
    ub = tmp(UBound(tmp))
    GetParentFolder = Replace(Join(tmp, "\"), "\" & ub, "")
End Function

Sub push(ary, value) 'this modifies parent ary object
    On Error GoTo init
    Dim x
    x = UBound(ary) '<-throws Error If Not initalized
    ReDim Preserve ary(UBound(ary) + 1)
    ary(UBound(ary)) = value
    Exit Sub
init:     ReDim ary(0): ary(0) = value
End Sub



Function isIde() As Boolean
' Brad Martinez  http://www.mvps.org/ccrp
    On Error GoTo out
    Debug.Print 1 / 0
out: isIde = Err
End Function


Function AryIsEmpty(ary) As Boolean
  On Error GoTo oops
    Dim i
    i = UBound(ary)  '<- throws error if not initalized
    AryIsEmpty = False
  Exit Function
oops: AryIsEmpty = True
End Function

Function KeyExistsInCollection(c As Collection, val As String) As Boolean
    On Error Resume Next
    Dim t
    t = c(val)
    If Err.Number = 0 Then
        KeyExistsInCollection = True
        Exit Function
    Else
        Err.Clear
        Set t = c(val) 'maybe its an object collection?
        KeyExistsInCollection = (Err.Number = 0)
    End If
End Function

Function c2s(c As Collection) As String
    Dim x, y
    If c.Count = 0 Then Exit Function
    For Each x In c
        y = y & x & ", "
    Next
    y = Mid(y, 1, Len(y) - 2)
    c2s = y
End Function

Function FolderExists(ByVal path As String) As Boolean
  On Error GoTo hell
  Dim tmp As String
  tmp = path & "\"
  If Len(tmp) = 1 Then Exit Function
  If Dir(tmp, vbDirectory) <> "" Then FolderExists = True
  Exit Function
hell:
    FolderExists = False
End Function

Function FileExists(ByVal path As String) As Boolean
  On Error GoTo hell
    
  If Len(path) = 0 Then Exit Function
  If Right(path, 1) = "\" Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
  
  Exit Function
hell: FileExists = False
End Function

Function ReadFile(fileName) As Variant
  Dim f As Long
  Dim temp As Variant
  f = FreeFile
  temp = ""
   Open fileName For Binary As #f        ' Open file.(can be text or image)
     temp = Input(FileLen(fileName), #f) ' Get entire Files data
   Close #f
   ReadFile = temp
End Function

Sub WriteFile(path, it)
    Dim f As Long
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
End Sub

Function AnyOfTheseInstr(sIn, sCmp) As Boolean
    Dim tmp() As String, i As Integer
    tmp() = Split(sCmp, ",")
    For i = 0 To UBound(tmp)
        tmp(i) = Trim(tmp(i))
        If Len(tmp(i)) > 0 And InStr(1, sIn, tmp(i), vbTextCompare) > 0 Then
            AnyOfTheseInstr = True
            Exit Function
        End If
    Next
End Function

'Function AryIsEmpty(ary) As Boolean
'  On Error GoTo oops
'  Dim i
'    i = UBound(ary)  '<- throws error if not initalized
'    AryIsEmpty = False
'  Exit Function
'oops: AryIsEmpty = True
'End Function


'Sub push(ary, value) 'this modifies parent ary object
'Dim x
'    On Error GoTo init
'    x = UBound(ary) '<-throws Error If Not initalized
'    ReDim Preserve ary(UBound(ary) + 1)
'    ary(UBound(ary)) = value
'    Exit Sub
'init:     ReDim ary(0): ary(0) = value
'End Sub

Sub papush(ary, ParamArray value()) 'this modifies parent ary object
    
    Dim i As Long, v
    
    If AryIsEmpty(ary) Then
        ReDim ary(0)
    Else
        push ary, ""
    End If
    
    i = UBound(ary)
    
    For Each v In value
        ary(i) = ary(i) & " " & v
    Next
    
End Sub



Function AryContains(elem As String, ary() As String, Optional caseSensitive As Boolean = True) As Boolean
    Dim x, match As Boolean
    
    If AryIsEmpty(ary) Then Exit Function
    
    For Each x In ary
    
        If caseSensitive Then
            If x = elem Then match = True
        Else
            If LCase(x) = LCase(elem) Then match = True
        End If
        
        If match Then
            AryContains = True
            Exit Function
        End If
        
    Next
    
End Function

Private Function dllPath(dll As String) As String
    Dim h As Long, ret As String
     ret = Space(500)
     h = GetModuleHandle(dll)
     h = GetModuleFileName(h, ret, 500)
     If h > 0 Then ret = Mid(ret, 1, h)
     ret = Trim(ret)
     dllPath = IIf(Len(ret) > 0, ret, "Not found: " & dll)
     If dll = "python311.dll" Then
        If Not timeoutEnabled Then
            dllPath = dllPath & " - DEFAULT"
        Else
            dllPath = dllPath & " - CUSTOM" ' & IIf(runFileEnabled, "/RunFile", "")
        End If
    End If
End Function

Public Function GetDllInfos() As String
     Dim tmp() As String, t As String
     push tmp, "Loaded DLLs: "
     'push tmp, dllPath("scivb2.ocx")
     'push tmp, dllPath("SciLexer.dll")
     push tmp, "  " & dllPath("python311.dll")
     push tmp, "  " & dllPath("py4vb.dll")
     GetDllInfos = Join(tmp, vbCrLf)
End Function


