VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Python Embedding Example"
   ClientHeight    =   8850
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10350
   LinkTopic       =   "Form1"
   ScaleHeight     =   8850
   ScaleWidth      =   10350
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtOut 
      Height          =   1815
      Left            =   765
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   4905
      Width           =   7800
   End
   Begin VB.TextBox txtData 
      Height          =   330
      Left            =   6615
      TabIndex        =   4
      Text            =   "test string from vb!"
      Top             =   7290
      Width           =   2040
   End
   Begin VB.ListBox List1 
      Height          =   1425
      Left            =   45
      TabIndex        =   2
      Top             =   7245
      Width           =   5190
   End
   Begin VB.CommandButton cmdExecPy 
      Caption         =   "Test COM"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8685
      TabIndex        =   1
      Top             =   4905
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4605
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   90
      Width           =   9825
   End
   Begin VB.Label Label2 
      Caption         =   "Output"
      Height          =   195
      Left            =   90
      TabIndex        =   5
      Top             =   4905
      Width           =   555
   End
   Begin VB.Label Label1 
      Caption         =   "TxtData"
      Height          =   240
      Left            =   5850
      TabIndex        =   3
      Top             =   7335
      Width           =   645
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim last As String
Public col As New Collection

Public Function alert(x)
    MsgBox x
    alert = 1
End Function

'make sure to install pywin32 package to test com:  pip install pywin32

Private Sub cmdExecPy_Click()
    Dim rv As Long, pFunc As Long, pArgs As Long, pVal As Long, oGVar1
    Dim args() As String
    
    On Error Resume Next
    WriteFile last, Text1.Text
    
    List1.Clear
    txtOut = Empty
    
    rv = PyOp(op_Init)
    la "Init = " & rv
    
    rv = PyOp(op_LoadCode, , Text1.Text)
        
    'if we call this, it only works first run..never finalize for COM to keep to working..
    'rv = PyOp(op_Final)
    'la "Finalize = " & rv
    
End Sub

Private Sub Form_Load()
    
    col.Add 2
    col.Add "test"
    col.Add Me
    
    Dim dll As String, pyDll As String, hPy As Long
    
    dll = App.path & "\..\py4vb.dll"
    last = App.path & "\com_test.py"
    
    If FileExists(last) Then Text1 = ReadFile(last)
    
    If Not FileExists(dll) Then dll = App.path & "\py4vb.dll"
    
    If FileExists(dll) Then
        la "Found: " & dll
    Else
        la "Failed to find py4vb.dll"
        Exit Sub
    End If
    
    'if you want to manually set a path to your 32 bit python install do it here (dont move the python311.dll)
    'pyDll = "c:\py311\python311.dll"
    
    If Len(pyDll) > 0 Then 'manually set
        If is32Bit(pyDll) Then
            la "manually set python311.dll confirmed 32 bit"
            'better preload it since it may not be in path..(will it find the imports? dunno better to be in path)
            'we could also use SetDllDirectory safer?
            hPy = LoadLibrary(pyDll)
            If hPy = 0 Then
                la "Failed to LoadLibrary(python311.dll)"
                Exit Sub
            Else
                la "Manually preloaded python311.dll ok: " & Hex(hPy)
            End If
        Else
            la "python311.dll is NOT 32 bit"
            Exit Sub
        End If
    Else
        If Not scanPathFor32bitPythonInstall(pyDll) Then
            la "Could not find 32bit python311.dll in path? probably wont work..."
        Else
            la "32 bit python found in path: " & pyDll
        End If
    End If
    
    
    If Not LoadPyLib(dll) Then
        la "Failed to Load py lib"
        Exit Sub
    Else
        la "Python loaded and ready"
    End If
    
    cmdExecPy.Enabled = True
    
    m_lCookie = PutObject(Me, "PyComTest.Form1")
    la "Put object handle:= " & Hex(m_lCookie)
    
    m_lCookie2 = PutObject(List1, "PyComTest.List1")
    la "Put object handle:= " & Hex(m_lCookie2)
    
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    WriteFile last, Text1.Text
    FreeLibrary hPyLib
    RevokeObject m_lCookie
    RevokeObject m_lCookie2
End Sub

Function la(x)
    On Error Resume Next
    List1.AddItem x
    List1.ListIndex = List1.ListCount - 1
End Function

