VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Python Embedding Example"
   ClientHeight    =   11070
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10200
   LinkTopic       =   "Form1"
   ScaleHeight     =   11070
   ScaleWidth      =   10200
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtOut 
      Height          =   1815
      Left            =   720
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   7380
      Width           =   7800
   End
   Begin VB.TextBox txtData 
      Height          =   330
      Left            =   6705
      TabIndex        =   4
      Text            =   "test string from vb!"
      Top             =   9540
      Width           =   2040
   End
   Begin VB.ListBox List1 
      Height          =   1425
      Left            =   135
      TabIndex        =   2
      Top             =   9495
      Width           =   5190
   End
   Begin VB.CommandButton cmdExecPy 
      Caption         =   "Thread Sample"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8640
      TabIndex        =   1
      Top             =   7380
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7035
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   90
      Width           =   9825
   End
   Begin VB.Label Label2 
      Caption         =   "Output"
      Height          =   195
      Left            =   45
      TabIndex        =   5
      Top             =   7380
      Width           =   555
   End
   Begin VB.Label Label1 
      Caption         =   "TxtData"
      Height          =   240
      Left            =   5940
      TabIndex        =   3
      Top             =   9585
      Width           =   645
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim last As String
Dim WithEvents sp As spSubClass.clsSubClass
Attribute sp.VB_VarHelpID = -1

Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
         
Const WM_COPYDATA = &H4A
Const WM_DISPLAY_TEXT = 3

Private Type COPYDATASTRUCT 'this works for both 32 and 64 bit ignore structure below it was testing..
    dwFlag As Long
    cbSize As Long
    lpData As Long
End Type

'make sure to install package:  pip install pypiwin32


Private Sub cmdExecPy_Click()
    Dim rv As Long, pFunc As Long, pArgs As Long, pVal As Long, oGVar1
    Dim args() As String
    
    On Error Resume Next
    WriteFile last, Text1.Text
    
    rv = PyOp(op_Final)
    la "Finalize = " & rv
    
    List1.Clear
    List1.Refresh
    DoEvents
    
    la "Starting: " & Now
    txtOut = Empty
    
    rv = PyOp(op_Init)
    la "Init = " & rv
    
    rv = PyOp(op_AddIntConst, Me.hwnd, "vb_hwnd")
    la "Set main.vb_hwnd = " & rv
    
    rv = PyOp(op_LoadCode, , Text1.Text)
    la "LoadCode = " & rv
    
    
End Sub

Private Sub Form_Load()
    
    Dim dll As String, pyDll As String, hPy As Long
    
    dll = App.path & "\..\py4vb.dll"
    last = App.path & "\threading.py"
    
    If FileExists(last) Then Text1 = ReadFile(last)
    
    If Not FileExists(dll) Then dll = App.path & "\py4vb.dll"
    
    If FileExists(dll) Then
        la "Found: " & dll
    Else
        la "Failed to find py4vb.dll"
        Exit Sub
    End If
    
    'if you want to manually set a path to your 32 bit python install do it here (dont move the python311.dll)
    'pyDll = "c:\py311\python311.dll"
    
    If Len(pyDll) > 0 Then 'manually set
        If is32Bit(pyDll) Then
            la "manually set python311.dll confirmed 32 bit"
            'better preload it since it may not be in path..(will it find the imports? dunno better to be in path)
            'we could also use SetDllDirectory safer?
            hPy = LoadLibrary(pyDll)
            If hPy = 0 Then
                la "Failed to LoadLibrary(python311.dll)"
                Exit Sub
            Else
                la "Manually preloaded python311.dll ok: " & Hex(hPy)
            End If
        Else
            la "python311.dll is NOT 32 bit"
            Exit Sub
        End If
    Else
        If Not scanPathFor32bitPythonInstall(pyDll) Then
            la "Could not find 32bit python311.dll in path? probably wont work..."
        Else
            la "32 bit python found in path: " & pyDll
        End If
    End If
    
    
    If Not LoadPyLib(dll) Then
        la "Failed to Load py lib"
        Exit Sub
    Else
        la "Python loaded and ready"
    End If
    
    Set sp = New clsSubClass
    sp.AttachMessage Me.hwnd, WM_COPYDATA
    
    la "Watching for WM_COPYDATA for main Window Hwnd: " & Me.hwnd
    cmdExecPy.Enabled = True
    
     
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    WriteFile last, Text1.Text
    FreeLibrary hPyLib
End Sub

Function la(x)
    On Error Resume Next
    List1.AddItem x
    List1.ListIndex = List1.ListCount - 1
End Function

Private Sub sp_MessageReceived(hwnd As Long, wMsg As Long, wParam As Long, lParam As Long, Cancel As Boolean)
    
    If wMsg = WM_COPYDATA Then RecieveTextMessage lParam
    
End Sub


Private Sub RecieveTextMessage(lParam As Long)
   
    Dim CopyData As COPYDATASTRUCT
    Dim Buffer(1 To 2048) As Byte
    Dim temp As String
    Dim lpData As Long
    Dim sz As Long
    Dim tmp() As Byte
    ReDim tmp(30)
    
    CopyMemory CopyData, ByVal lParam, Len(CopyData)
    
    If CopyData.dwFlag = 3 Then
    
        CopyMemory tmp(0), ByVal lParam, Len(CopyData)
        'Text1 = HexDump(tmp, Len(CopyData))
        
        lpData = CopyData.lpData
        sz = CopyData.cbSize
    Else
        List1.AddItem "Unknown flag: " & CopyData.dwFlag
        Exit Sub
    End If
    
    If sz > 2048 Then
        List1.AddItem "Size(" & Hex(sz) & " ) > buffer (2048)"
        Exit Sub
    End If
    
    'List1.AddItem "lpData: " & Hex(lpData)
    'List1.AddItem "Size: " & Hex(sz)
    
    CopyMemory Buffer(1), ByVal lpData, sz
    temp = StrConv(Buffer, vbUnicode)
    temp = Left$(temp, InStr(1, temp, Chr$(0)) - 1)
    'heres where we work with the intercepted message
    la "***** Message Received: " & temp
    
    
End Sub

