Attribute VB_Name = "mPy4VB"
Option Explicit

Public hPyLib As Long

Public Declare Sub SetCallBacks Lib "py4VB.dll" ( _
    ByVal msgProc As Long, _
    Optional ByVal dbgCmdProc As Long = 0, _
    Optional ByVal hostResolverProc As Long = 0, _
    Optional ByVal lineInputfunc As Long = 0, _
    Optional ByVal dbgWrite As Long = 0)
    
Public Declare Function PyOp Lib "py4VB.dll" (ByVal operation As opPy, Optional ByVal arg1 As Long, Optional ByVal sArg As String) As Long
Public Declare Function SetArgv Lib "py4VB.dll" (args As Variant) As Long 'must be string array passing as variant to prevent ascii conversion.

'int __stdcall SetItem(PyObject* pArgs, int sz, PyObject* pVal) {
Public Declare Function SetItem Lib "py4VB.dll" (ByVal pArgs As Long, Optional ByVal sz As Long, Optional ByVal pVal As Long) As Long

'PyObject* __stdcall CallObject(PyObject* pFunc, PyObject* pArgs) {
Public Declare Function CallObject Lib "py4VB.dll" (ByVal pFunc As Long, ByVal pArgs As Long) As Long

'VARIANT* __stdcall GetStr(PyObject* po)'this def vb puts an Variant* on stack and wacks first arg in C
'int __stdcall GetStr(PyObject* po, VARIANT* v)
Public Declare Function GetStr Lib "py4VB.dll" (ByVal pyObj As Long, ByRef v As Variant) As Long


'misc windows api..
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, Source As Any, ByVal length As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" (ByVal lpString As Long) As Long

Enum cb_type
    cb_output = 0
    cb_error = 1
    cb_Refresh = 2
End Enum

Enum opPy
    op_Init = 0
    op_Final = 1
    op_LoadCode = 2
    op_GetFunc = 3
    op_CreateArgs = 4
    op_CreateLong = 5
    op_CheckLong = 6
    op_GetLong = 7
    op_isString = 8
    op_isBool = 9
    op_isList = 10
    op_ListSize = 11
    op_GlobalFromName = 12
    op_AddIntConst = 13
    op_ImportMod = 14
End Enum

Public LastStringReturn As String


Function scanPathFor32bitPythonInstall(ByRef pyHome As String) As Boolean
    Dim p, pp() As String, dll As String
    
    pyHome = Empty
    p = Environ("path")
    pp = Split(p, ";")
    
    For Each p In pp
        dll = p & "\python311.dll"
        If FileExists(dll) Then
            If is32Bit(dll) Then
                pyHome = dll
                scanPathFor32bitPythonInstall = True
                Exit Function
            End If
        End If
    Next
    
End Function

Function is32Bit(ByVal exe As String) As Boolean
    
    Dim f As Long, i As Integer
    Dim stamp As Long, e_lfanew As Long
    Dim base As Date, compiled As Date
    Dim machine As Integer
    
    Const mt_I386 = &H14C
    Const mt_IA64 = &H200

    On Error GoTo errExit
        
    FileLen exe 'throw error if not exist
    
    f = FreeFile
    Open exe For Binary Access Read As f
    Get f, , i
    
    If i <> &H5A4D Then GoTo errExit 'MZ check
     
    Get f, 60 + 1, e_lfanew
    Get f, e_lfanew + 1, i
    
    If i <> &H4550 Then GoTo errExit 'PE check (IMAGE_NT_HEADERS)
    
'    Public Type IMAGE_NT_HEADERS
'        Signature As String * 4
'        'FileHeader As IMAGE_FILE_HEADER
'            Machine As Integer
'            NumberOfSections As Integer
'            TimeDateStamp As Long

'    Get f, e_lfanew + 9, stamp
    
    Get f, e_lfanew + 5, machine
    Close f
    
    If machine = mt_I386 Then
        is32Bit = True
    ElseIf machine <> mt_IA64 Then
        Debug.Print "Unknown machine: " & Hex(machine)
    End If
        
'    base = DateSerial(1970, 1, 1)
'    compiled = DateAdd("s", stamp, base)
'    GetCompileTime = Format(compiled, "ddd, mmm d yyyy, h:nn:ss ")
    
    Exit Function
    
errExit:
    On Error Resume Next
    Close f
        
End Function

Function LoadPyLib(Optional ByVal explicitPathToDll As String) As Boolean
    
    If Len(explicitPathToDll) = 0 Then
        explicitPathToDll = App.path
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = GetParentFolder(explicitPathToDll)
            If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
                explicitPathToDll = GetParentFolder(explicitPathToDll)
                If Not FileExists(explicitPathToDll & "\py4vb.dll") Then explicitPathToDll = GetParentFolder(explicitPathToDll)
            End If
        End If
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = Empty
        Else
            explicitPathToDll = explicitPathToDll & "\py4vb.dll"
        End If
    End If

    If FileExists(explicitPathToDll) Then
        hPyLib = LoadLibrary(explicitPathToDll) 'to ensure the ide finds the dll
        If hPyLib = 0 Then Exit Function
    End If
    
    'this can still work..but now its up to the runtime to find the dll..if not the app will terminate
    SetCallBacks AddressOf vb_stdout, 0, AddressOf HostResolver
    LoadPyLib = True
    
End Function

'this is used for script to host app object integration..
Public Function HostResolver(ByVal buf As Long, ByVal ctx As Long, ByVal argCnt As Long, ByVal hInst As Long) As Long
'    Dim key As String
'    Dim v1 As Variant
'
'    On Error Resume Next
'    'we could switch to numeric ids..but it would be harder to manage/debug when more complex..
'    key = StringFromPointer(buf)
'
'    'this is just a quick demo not the full setup see duk4vb project for a full COM relay using same structure
'    If key = "list1.additem" Then
'        If argCnt > 1 Then
'            v1 = GetArgAsString(ctx, i + 3)
'            Form1.List1.AddItem CStr(v1)
'        End If
'    End If
'
'    If key = "text2.text" Then
'        DukOp opd_PushStr, ctx, 0, Form1.Text2.text
'        HostResolver = 1
'    End If
            
End Function
    
    
Function GetLastString() As String
'    Dim rv As Long
'    rv = DukOp(opd_LastString)
'    If rv = 0 Then Exit Function
'    GetLastString = StringFromPointer(rv)
End Function



Function GetArgAsString(ctx As Long, index As Long) As String
    
'    'an invalid index here would trigger a script error and aborting the eval call..weird.. <---
'    'as long as the native function is added with expected arg count, and you dont surpass it your ok
'    'even if the js function ommitted args in its call, empty ones will just be retrieved as 'undefined'
'
'    Dim ptr As Long
'    ptr = DukOp(opd_GetString, ctx, index)
'
'    If ptr <> 0 Then
'        GetArgAsString = StringFromPointer(ptr)
'    End If
    
End Function
 




'callback functions
'------------------------------
Public Sub vb_stdout(ByVal t As cb_type, ByVal lpMsg As Long)

    Dim msg As String
    
    If t = cb_Refresh Then
        DoEvents
        Sleep 3
        Exit Sub
    End If
    
    If lpMsg = 0 Then Exit Sub
    
    msg = StringFromPointer(lpMsg)
    'Debug.Print msg
    
    Select Case t
        'Case cb_StringReturn: LastStringReturn = msg
        Case cb_output:
                With Form1.txtOut
                    .Text = .Text & Replace(msg, vbLf, vbCrLf)
                    .SelStart = Len(.Text)
                End With
                
        Case cb_error:
                Form1.List1.AddItem "error: " & msg
    End Select
    
End Sub


Public Function VbLineInput(ByVal buf As Long, ByVal ctx As Long) As Long
'    Dim b() As Byte
'    Dim retVal As String
'    VbLineInput = 0 'return value default..
'
'    Dim text As String
'    Dim def As String
'
'    text = StringFromPointer(buf)
'    def = GetArgAsString(ctx, 1)
'
'    retVal = InputBox(text, "Script Basic Line Input", def)
'
'    If Len(retVal) = 0 Then
'        DukOp opd_PushUndef, ctx
'        Exit Function
'    Else
'        DukOp opd_PushStr, ctx, 0, retVal
'    End If
        
  
End Function

Function StringFromPointer(buf As Long) As String
    Dim sz As Long
    Dim tmp As String
    Dim b() As Byte
    
    If buf = 0 Then Exit Function
       
    sz = lstrlen(buf)
    If sz = 0 Then Exit Function
    
    ReDim b(sz)
    CopyMemory b(0), ByVal buf, sz
    tmp = StrConv(b, vbUnicode)
    If Right(tmp, 1) = Chr(0) Then tmp = Left(tmp, Len(tmp) - 1)
    
    StringFromPointer = tmp
 
End Function

Sub dbg(prefix As String, ParamArray args())
    Dim a, tmp As String
    
    tmp = prefix
    
    For Each a In args
        If IsNumeric(a) Then
            tmp = tmp & Hex(a) & ", "
        ElseIf IsObject(a) Then
            tmp = tmp & "Obj: " & TypeName(a) & ", "
        Else
            tmp = tmp & a & ", "
        End If
    Next
    
    Form1.List1.AddItem tmp
    Debug.Print tmp
    
End Sub

Function GetParentFolder(path) As String
    On Error Resume Next
    Dim tmp() As String, ub
    If Len(path) = 0 Then Exit Function
    tmp = Split(path, "\")
    ub = tmp(UBound(tmp))
    GetParentFolder = Replace(Join(tmp, "\"), "\" & ub, "")
End Function

Sub push(ary, value) 'this modifies parent ary object
    On Error GoTo init
    Dim x
    x = UBound(ary) '<-throws Error If Not initalized
    ReDim Preserve ary(UBound(ary) + 1)
    ary(UBound(ary)) = value
    Exit Sub
init:     ReDim ary(0): ary(0) = value
End Sub



Function IsIde() As Boolean
' Brad Martinez  http://www.mvps.org/ccrp
    On Error GoTo out
    Debug.Print 1 / 0
out: IsIde = Err
End Function


Function AryIsEmpty(ary) As Boolean
  On Error GoTo oops
    Dim i
    i = UBound(ary)  '<- throws error if not initalized
    AryIsEmpty = False
  Exit Function
oops: AryIsEmpty = True
End Function

Function KeyExistsInCollection(c As Collection, val As String) As Boolean
    On Error Resume Next
    Dim t
    t = c(val)
    If Err.Number = 0 Then
        KeyExistsInCollection = True
        Exit Function
    Else
        Err.Clear
        Set t = c(val) 'maybe its an object collection?
        KeyExistsInCollection = (Err.Number = 0)
    End If
End Function

Function c2s(c As Collection) As String
    Dim x, y
    If c.Count = 0 Then Exit Function
    For Each x In c
        y = y & x & ", "
    Next
    y = Mid(y, 1, Len(y) - 2)
    c2s = y
End Function

Function FolderExists(ByVal path As String) As Boolean
  On Error GoTo hell
  Dim tmp As String
  tmp = path & "\"
  If Len(tmp) = 1 Then Exit Function
  If Dir(tmp, vbDirectory) <> "" Then FolderExists = True
  Exit Function
hell:
    FolderExists = False
End Function

Function FileExists(ByVal path As String) As Boolean
  On Error GoTo hell
    
  If Len(path) = 0 Then Exit Function
  If Right(path, 1) = "\" Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
  
  Exit Function
hell: FileExists = False
End Function

Function ReadFile(filename) As Variant
  Dim f As Long
  Dim temp As Variant
  f = FreeFile
  temp = ""
   Open filename For Binary As #f        ' Open file.(can be text or image)
     temp = Input(FileLen(filename), #f) ' Get entire Files data
   Close #f
   ReadFile = temp
End Function

Sub WriteFile(path, it)
    Dim f As Long
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
End Sub

