VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Python Embedding Example"
   ClientHeight    =   10830
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10350
   LinkTopic       =   "Form1"
   ScaleHeight     =   10830
   ScaleWidth      =   10350
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtOut 
      Height          =   3930
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   6615
      Width           =   4380
   End
   Begin VB.ListBox List1 
      Height          =   3375
      Left            =   4545
      TabIndex        =   2
      Top             =   7065
      Width           =   5190
   End
   Begin VB.CommandButton cmdExecPy 
      Caption         =   "Execute Python"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8505
      TabIndex        =   1
      Top             =   6615
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6405
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   90
      Width           =   9825
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim last As String
 
Function dumpType(globalName As String)
    
    On Error Resume Next
    
    Dim o As Long, v, t As pyTypes, i As Long, tmp As String, x, customType As String
    
    
    t = typeForName(globalName, o)
    If t = pt_unknown Then customType = getTypeName(o)
    
    v = getValue(o)
    
    If TypeName(v) = "Null" Then v = "Null"
    
    If TypeName(v) = "Variant()" Then
        v = Join(v, ",")
        If Err.Number <> 0 Then 'it contains complex types in array we cant join...
            For Each x In v
                Err.Clear
                If TypeName(x) = "Byte()" Then
                    tmp = tmp & "<" & TypeName(x) & "> ," 'dont let these auto convert
                Else
                    tmp = tmp & x & "," 'can this auto convert?
                    If Err.Number <> 0 Then
                        tmp = tmp & "<" & TypeName(x) & "> ," 'no? ok just show type for dump
                    End If
                End If
            Next
            v = tmp
        End If
        dumpType = v
    End If
    
    If TypeName(v) = "Byte()" Then
        For i = 0 To UBound(v)
            tmp = tmp & Right("0" & Hex(v(i)), 2) & " "
        Next
        v = tmp
    End If
    
    If t = pt_unknown Then
        la "type(" & globalName & ") customType=" & customType & " value=" & v
    Else
        la "type(" & globalName & ") type=" & typeToStr(t) & " value=" & v
    End If
    
End Function

Private Sub cmdExecPy_Click()
    Dim rv As Long, pFunc As Long, pArgs As Long, pVal As Long, oGVar1
    Dim args() As String
    
    On Error Resume Next
    WriteFile last, Text1.Text
    
    List1.Clear
    txtOut = Empty
    
    rv = PyOp(op_Init)
    la "Init = " & rv
    
    'rv = PyOp(op_AddIntConst, 777, "gInitVal")
    'la "Set main.gInitVal = " & rv
    
    rv = PyOp(op_LoadCode, , Text1.Text)
    la "LoadCode = " & rv
 
    dumpType "a"
    dumpType "b"
    dumpType "c"
    dumpType "d"
    dumpType "e"
    dumpType "f"
    dumpType "g"
    dumpType "h"
    dumpType "i"
    dumpType "j"
    dumpType "k"
    dumpType "mc"
    
    'now lets transfer a vb array into python as a tuple..
    push args, 5
    push args, "test"
    push args, "ary"
    push args, 21
    
    pVal = VariantToPyObj(args)
    If pVal <> 0 Then
        rv = PyOp(op_AddObj, pVal, "gTupleFromVB")
        If rv = 0 Then
            Debug.Print "add tuple from vb success"
            Call PyOp(op_LoadCode, , "print(gTupleFromVB)")
        End If
        rv = decref(pVal)
        la "gTupleFromVB ref cnt now = " & rv
    End If
    
    rv = PyOp(op_Final)
    la "Finalize = " & rv
    
End Sub

Private Sub Form_Load()
    
    Dim dll As String, pyDll As String, hPy As Long
    
    dll = App.path & "\..\py4vb.dll"
    last = App.path & "\last.py"
    
    If FileExists(last) Then Text1 = ReadFile(last)
    
    If Not FileExists(dll) Then dll = App.path & "\py4vb.dll"
    
    If FileExists(dll) Then
        la "Found: " & dll
    Else
        la "Failed to find py4vb.dll"
        Exit Sub
    End If
    
    'if you want to manually set a path to your 32 bit python install do it here (dont move the python311.dll)
    'pyDll = "c:\py311\python311.dll"
    
    If Len(pyDll) > 0 Then 'manually set
        If is32Bit(pyDll) Then
            la "manually set python311.dll confirmed 32 bit"
            'better preload it since it may not be in path..(will it find the imports? dunno better to be in path)
            'we could also use SetDllDirectory safer?
            hPy = LoadLibrary(pyDll)
            If hPy = 0 Then
                la "Failed to LoadLibrary(python311.dll)"
                Exit Sub
            Else
                la "Manually preloaded python311.dll ok: " & Hex(hPy)
            End If
        Else
            la "python311.dll is NOT 32 bit"
            Exit Sub
        End If
    Else
        If Not scanPathFor32bitPythonInstall(pyDll) Then
            la "Could not find 32bit python311.dll in path? probably wont work..."
        Else
            la "32 bit python found in path: " & pyDll
        End If
    End If
    
    
    If Not LoadPyLib(dll) Then
        la "Failed to Load py lib"
        Exit Sub
    Else
        la "Python loaded and ready"
    End If
    
    cmdExecPy.Enabled = True
    
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    WriteFile last, Text1.Text
    FreeLibrary hPyLib
End Sub

Function la(x)
    On Error Resume Next
    List1.AddItem x
    List1.ListIndex = List1.ListCount - 1
End Function
