Attribute VB_Name = "py4VB"
Option Explicit

'Author:  David Zimmer <dzzie@yahoo.com>
'Site:    http://sandsprite.com

Public hPyLib As Long
Private timeoutEnabled As Boolean

Public Declare Sub SetCallBacks Lib "py4VB.dll" ( _
    ByVal msgProc As Long, _
    Optional ByVal dbgCmdProc As Long = 0, _
    Optional ByVal hostResolverProc As Long = 0, _
    Optional ByVal lineInputfunc As Long = 0, _
    Optional ByVal dbgWrite As Long = 0)
    
'requires a specially built python dll, we will test for it before using..
Private Declare Sub SetTimeoutCallBack Lib "python311.dll" Alias "_SetTimeoutCallBack@4" (ByVal TimeoutProc As Long)
Private Declare Sub SetGlobalAbort Lib "python311.dll" Alias "_SetGlobalAbort@4" (ByVal gAbort As Long)

Public Declare Function About_py4vb Lib "py4VB.dll" () As Variant

Public Declare Function PyOp Lib "py4VB.dll" (ByVal operation As opPy, Optional ByVal arg1 As Long, Optional ByVal sArg As String, Optional ByVal arg3 As Long) As Long
Public Declare Function PyCheck Lib "py4VB.dll" (ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long
Public Declare Function PySize Lib "py4VB.dll" (ByVal operation As pyTypes, Optional ByVal arg1 As Long) As Long

Public Declare Function SetArgv Lib "py4VB.dll" (args As Variant) As Long 'must be string array passing as variant to prevent ascii conversion.

'int __stdcall SetItem(PyObject* pArgs, int sz, PyObject* pVal) {
Public Declare Function SetItem Lib "py4VB.dll" (ByVal pArgs As Long, Optional ByVal sz As Long, Optional ByVal pVal As Long) As Long

'PyObject* __stdcall CallObject(PyObject* pFunc, PyObject* pArgs) {
Public Declare Function CallObject Lib "py4VB.dll" (ByVal pFunc As Long, ByVal pArgs As Long) As Long

'VARIANT* __stdcall GetStr(PyObject* po)'this def vb puts an Variant* on stack and wacks first arg in C
'int __stdcall GetStr(PyObject* po, VARIANT* v)
Public Declare Function GetStr Lib "py4VB.dll" (ByVal pyObj As Long, ByRef v As Variant) As Long

'handle to a python object auto convert to vb type, even arrays (not dicts)
Public Declare Function ObjToVariant Lib "py4VB.dll" (ByVal pyObj As Long, ByRef v As Variant) As Long

'take a vb type and convert it to a python object handle
Public Declare Function VariantToPyObj Lib "py4VB.dll" (ByRef v As Variant) As Long

'misc windows api..
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, Source As Any, ByVal length As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" (ByVal lpString As Long) As Long
Public Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Enum cb_type
    cb_output = 0
    cb_error = 1
    cb_Refresh = 2
    cb_StringReturn = 3
End Enum

Enum dcb_type
    dcb_dbg = 0
    dcb_callstack = 1
    dcb_globals = 2
    dcb_locals = 3
    dcb_args = 4
End Enum

Enum opPy
    op_Init = 0
    op_Final = 1
    op_LoadCode = 2
    op_GetFunc = 3
    op_NewTuple = 4
    op_CreateLong = 5
    op_GetLong = 7
    op_GetAttrStr = 12
    op_AddIntConst = 13
    op_ImportMod = 14
    op_interrupt = 15
    op_decref = 16
    op_incref = 17
    op_refcnt = 18
    op_AddObj = 19
    op_TypeName = 20
    op_HasLen = 21
    op_NewStr = 22
    op_GetMod = 23
    op_eval = 24
End Enum

Enum pyTypes
    pt_notFound = -1
    pt_unknown = 0
    pt_String = 1
    pt_Bool = 2
    pt_List = 3
    pt_Long = 4
    pt_Tuple = 5
    pt_Float = 6
    pt_Dict = 7
    pt_Complex = 8
    pt_Bytes = 9
    pt_ByteAry = 10
    pt_None = 11
    pt_isTrue = 12
    pt_set = 13
End Enum

Public LastStringReturn As String
Public SharedObjects As New Collection 'used by host resolver
Private ABORT_SCRIPT As Boolean

Function eval(ByVal pyCode As String, Optional ret_hObj As Boolean = False) As Variant
    
    Dim hRet As Long
    
    hRet = PyOp(op_eval, , pyCode)
    
    If ret_hObj Then
        eval = hRet
    ElseIf hRet <> 0 Then
        eval = getValue(hRet)
        decref hRet
    End If
    
End Function

Function refCnt(obj As Long) As Long
    refCnt = PyOp(op_refcnt, obj)
End Function

Function incref(obj As Long) As Long
    incref = PyOp(op_incref, obj) 'returns refcnt
End Function

Function decref(obj As Long) As Long
    decref = PyOp(op_decref, obj) 'returns refcnt
End Function


Function getTypeName(obj As Long) As String
    Dim p As Long
    p = PyOp(op_TypeName, obj)
    If p <> 0 And p <> -1 Then
        getTypeName = StringFromPointer(p)
    End If
End Function

Function typeForName(globalName As String, Optional ByRef obj As Long) As pyTypes

    obj = PyOp(op_GetAttrStr, , globalName)
    
    If obj = -1 Then
        typeForName = pt_notFound
        Exit Function
    End If
    
    If obj = 0 Or obj = -1 Then Exit Function
    
    typeForName = getType(obj)
    
End Function

'complex and dict fail
Function getValue(obj As Long) As Variant

    Dim v As Variant, rv As Long, rc As Long, t As pyTypes
    
    'rc = PyOp(op_refcnt, obj)
    'Debug.Print "refcnt: " & rc
    
    t = getType(obj)
    
    'If PyCheck(pt_Dict, obj) Or PyCheck(pt_Complex, obj) Or PyCheck(pt_set, obj) Then
    If t = pt_Dict Or t = pt_Complex Or t = pt_set Or t = pt_unknown Then
        rv = GetStr(obj, v)
        If rv = 1 Then
            'Debug.Print "getValue.GetStr = " & rv & " type=" & TypeName(v)
            getValue = v
        End If
        Exit Function
    End If
    
    'rc = PyOp(op_refcnt, obj)
    'Debug.Print "refcnt: " & rc
    
    rv = ObjToVariant(obj, v)
    If rv = 1 Then getValue = v
    
    'Debug.Print "getValue.ObjToVariant = " & rv & " type=" & TypeName(v)
    
    'rc = PyOp(op_refcnt, obj)
    'Debug.Print "refcnt: " & rc
    
     
    
    
    
    
'    Select Case t
'        Case pt_String:
'                        rv = GetStr(obj, v)
'                        If rv = 1 Then getValue = CStr(v)
'
'        Case pt_isLong: getValue = CLng(PyOp(op_GetLong, obj))
'        Case pt_bool: getValue = IIf(PyCheck(pt_isTrue, obj) = 1, True, False)

'    End Select
    
End Function

Function getType(obj As Long) As pyTypes
    If PyCheck(pt_String, obj) = 1 Then getType = pt_String
    If PyCheck(pt_Long, obj) = 1 Then getType = pt_Long
    If PyCheck(pt_Bool, obj) = 1 Then getType = pt_Bool
    If PyCheck(pt_List, obj) = 1 Then getType = pt_List
    If PyCheck(pt_Tuple, obj) = 1 Then getType = pt_Tuple
    If PyCheck(pt_Float, obj) = 1 Then getType = pt_Float
    If PyCheck(pt_Dict, obj) = 1 Then getType = pt_Dict
    If PyCheck(pt_Complex, obj) = 1 Then getType = pt_Complex
    If PyCheck(pt_Bytes, obj) = 1 Then getType = pt_Bytes
    If PyCheck(pt_ByteAry, obj) = 1 Then getType = pt_ByteAry
    If PyCheck(pt_None, obj) = 1 Then getType = pt_None
    If PyCheck(pt_set, obj) = 1 Then getType = pt_set
End Function

Function typeToStr(t As pyTypes) As String

    Select Case t
        Case pt_String: typeToStr = "String"
        Case pt_Long: typeToStr = "Long"
        Case pt_Bool: typeToStr = "Bool"
        Case pt_List: typeToStr = "List"
        Case pt_Tuple: typeToStr = "Tuple"
        Case pt_Float: typeToStr = "Float"
        Case pt_Dict: typeToStr = "Dict"
        Case pt_Complex: typeToStr = "Complex"
        Case pt_Bytes: typeToStr = "Bytes"
        Case pt_ByteAry: typeToStr = "ByteArray"
        Case pt_notFound: typeToStr = "Not Found"
        Case pt_None: typeToStr = "None"
        Case pt_set: typeToStr = "Set"
        Case Else: typeToStr = "Unknown"
    End Select
    
End Function


Function scanPathFor32bitPythonInstall(ByRef pyHome As String) As Boolean
    Dim p, pp() As String, dll As String
    
    pyHome = Empty
    p = Environ("path")
    pp = Split(p, ";")
    
    For Each p In pp
        dll = p & "\python311.dll"
        If FileExists(dll) Then
            If is32Bit(dll) Then
                pyHome = dll
                scanPathFor32bitPythonInstall = True
                Exit Function
            End If
        End If
    Next
    
End Function

Function is32Bit(ByVal exe As String) As Boolean
    
    Dim f As Long, i As Integer
    Dim stamp As Long, e_lfanew As Long
    Dim base As Date, compiled As Date
    Dim machine As Integer
    
    Const mt_I386 = &H14C
    Const mt_IA64 = &H200

    On Error GoTo errExit
        
    FileLen exe 'throw error if not exist
    
    f = FreeFile
    Open exe For Binary Access Read As f
    Get f, , i
    
    If i <> &H5A4D Then GoTo errExit 'MZ check
     
    Get f, 60 + 1, e_lfanew
    Get f, e_lfanew + 1, i
    
    If i <> &H4550 Then GoTo errExit 'PE check (IMAGE_NT_HEADERS)
    
'    Public Type IMAGE_NT_HEADERS
'        Signature As String * 4
'        'FileHeader As IMAGE_FILE_HEADER
'            Machine As Integer
'            NumberOfSections As Integer
'            TimeDateStamp As Long

'    Get f, e_lfanew + 9, stamp
    
    Get f, e_lfanew + 5, machine
    Close f
    
    If machine = mt_I386 Then
        is32Bit = True
    ElseIf machine <> mt_IA64 Then
        Debug.Print "Unknown machine: " & Hex(machine)
    End If
        
'    base = DateSerial(1970, 1, 1)
'    compiled = DateAdd("s", stamp, base)
'    GetCompileTime = Format(compiled, "ddd, mmm d yyyy, h:nn:ss ")
    
    Exit Function
    
errExit:
    On Error Resume Next
    Close f
        
End Function


Public Function cb_TimeoutHandler(ByVal t As Long, ByVal lpMsg As Long) As Long
    'return 1 to halt execution, 0 to continue
    
    DoEvents 'allow our timer and UI to breath in case its a dead loop
    
    If ABORT_SCRIPT Then
        cb_TimeoutHandler = 1
        Debug.Print "Aborting!"
    Else
        cb_TimeoutHandler = 0
    End If
    
End Function

Function AbortScript(Optional abort As Boolean = True) As Boolean
    If Not timeoutEnabled Then Exit Function
    ABORT_SCRIPT = abort
    SetGlobalAbort IIf(abort, 1, 0)
    AbortScript = True
End Function

Function UseTimeoutHandler() As Boolean
    
    Dim h As Long, p As Long
    h = LoadLibrary("python311.dll")
    If h = 0 Then Exit Function
    
    p = GetProcAddress(h, "_SetTimeoutCallBack@4")
    If p = 0 Then Exit Function
    
    SetTimeoutCallBack AddressOf cb_TimeoutHandler
    SetGlobalAbort 0
    UseTimeoutHandler = True
    timeoutEnabled = True
    
End Function

Function LoadPyLib(Optional ByVal explicitPathToDll As String) As Boolean
    
    If Len(explicitPathToDll) = 0 Then
        explicitPathToDll = App.path
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = GetParentFolder(explicitPathToDll)
            If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
                explicitPathToDll = GetParentFolder(explicitPathToDll)
                If Not FileExists(explicitPathToDll & "\py4vb.dll") Then explicitPathToDll = GetParentFolder(explicitPathToDll)
            End If
        End If
        If Not FileExists(explicitPathToDll & "\py4vb.dll") Then
            explicitPathToDll = Empty
        Else
            explicitPathToDll = explicitPathToDll & "\py4vb.dll"
        End If
    End If

    If FileExists(explicitPathToDll) Then
        hPyLib = LoadLibrary(explicitPathToDll) 'to ensure the ide finds the dll
        If hPyLib = 0 Then Exit Function
    End If
    
    'this can still work..but now its up to the runtime to find the dll..if not the app will terminate
    SetCallBacks AddressOf vb_stdout, AddressOf cb_dbgOut, AddressOf HostResolver

    If UseTimeoutHandler Then
        Debug.Print "Timeout handler set!"
    End If
    
    LoadPyLib = True
    
End Function


#If debugExample = 0 Then

Public Function cb_dbgOut(ByVal t As dcb_type, ByVal lpMsg As Long) As Long
End Function

#Else

'just because this references some Form1 objects not found in other examples..
'but want to use single bas file for syncing..
Public Function cb_dbgOut(ByVal t As dcb_type, ByVal lpMsg As Long) As Long

    Dim msg As String, tmp() As String, src As String

    If lpMsg = 0 Then Exit Function

    msg = StringFromPointer(lpMsg)

    'debug.print "dbgOut: " & msg
    
    If t = dcb_callstack Then
        ParseCallStack msg
        Exit Function
    End If
    
    If t = dcb_args Then
        ParseArgs msg
        Exit Function
    End If
    
    If t = dcb_locals Then
        ParseLocals msg
        Exit Function
    End If
    
    If t = dcb_globals Then
        ParseGlobals msg
        Exit Function
    End If
    
    If t = dcb_dbg Then
 
        '{line_no},{event},{func_name},{filename},{caller_line_no},{caller_func_name},{caller_filename}"")" & vbCrLf & _

        tmp = Split(msg, ",")
        Status.lineNumber = tmp(0)
        Status.eventName = tmp(1)
        Status.curFunc = tmp(2)
        Status.filename = tmp(3) 'only the current evaled string, others filtered out..
        Status.callerLineNum = tmp(4)
        Status.callerFuncName = tmp(5)
        Status.callerFileName = tmp(6)
        
        If BreakPointExists("<string>", Status.lineNumber - 1) Then
            Status.state = rm_stepIn
        End If
        
        If Len(Status.stepOverBreakOnFunc) > 0 Then
            If Status.stepOverBreakOnFunc = Status.curFunc Then
                Status.stepOverBreakOnFunc = Empty
                Status.stepOverCallerFrame = Empty
                Status.state = rm_stepIn
            End If
        End If
        
        If Len(Status.stepOverCallerFrame) > 0 Then 'trying to catch it on error or step over a return
            If Status.stepOverCallerFrame = Status.curFunc Then
                Status.stepOverBreakOnFunc = Empty
                Status.stepOverCallerFrame = Empty
                Status.state = rm_stepIn
            End If
        End If
        
        If Status.state = rm_run Then Exit Function
        
        If Status.state = rm_runToLine Then
            If Status.lineNumber <> Status.stepToLine Then Exit Function
            Status.state = rm_stepIn
        End If
        
        If Status.state = rm_stepOut Then
            If Status.eventName = "return" And Status.stepOutFunc = Status.curFunc Then
                Status.state = rm_stepIn
                Status.stepOutFunc = Empty
            End If
        End If
        
        'if status.state = rm_stepOver 'todo
        
        src = Form1.scivb.GetLineText(Status.lineNumber - 1)
        src = Trim(Replace(Replace(Replace(src, vbTab, ""), vbCr, Empty), vbLf, Empty))
        'Form1.la status.lineNumber & ":" & Len(src) & ":" & src
        
        If Len(src) = 0 Then Exit Function 'not sure why this is happening
        If LCase(Left(src, 6)) = "import" Then Exit Function 'no need to show the user these steps
        If LCase(Left(src, 4)) = "from" Then Exit Function
        If LCase(Left(src, 4)) = "def " Then Exit Function
        
        If Status.state = rm_stepIn Then
        
            SyncUI
            
            waitingToContinue = True
            Do While waitingToContinue
                DoEvents
                Sleep 5
            Loop
            
            If Status.state = rm_stepOver Then
                Status.stepOverBreakOnFunc = Status.curFunc
                Status.stepOverCallerFrame = Status.callerFuncName
                Status.state = rm_run
            End If
        
            If Status.state = rm_stop Then PyOp op_interrupt 'can this be masked with exception handling?
            
        End If

        Exit Function
    End If
    
End Function

#End If

'this is used for script to host app object integration..
Public Function HostResolver(ByVal buf As Long, ByVal v1 As Long, ByVal v2 As Long, ByVal v3 As Long) As Long
    
    On Error Resume Next
    
    Dim key As String
    Dim o As Object

    key = LCase(StringFromPointer(buf))
    Set o = SharedObjects(key)
    
    If Not o Is Nothing Then
        HostResolver = ObjPtr(o)
    Else
        HostResolver = 0
    End If
      
End Function
    
    
Function GetLastString() As String
'    Dim rv As Long
'    rv = DukOp(opd_LastString)
'    If rv = 0 Then Exit Function
'    GetLastString = StringFromPointer(rv)
End Function



Function GetArgAsString(ctx As Long, index As Long) As String
    
'    'an invalid index here would trigger a script error and aborting the eval call..weird.. <---
'    'as long as the native function is added with expected arg count, and you dont surpass it your ok
'    'even if the js function ommitted args in its call, empty ones will just be retrieved as 'undefined'
'
'    Dim ptr As Long
'    ptr = DukOp(opd_GetString, ctx, index)
'
'    If ptr <> 0 Then
'        GetArgAsString = StringFromPointer(ptr)
'    End If
    
End Function
 




'callback functions
'------------------------------
Public Sub vb_stdout(ByVal t As cb_type, ByVal lpMsg As Long)

    Dim msg As String
    
    If t = cb_Refresh Then
        DoEvents
        Sleep 3
        Exit Sub
    End If
    
    If lpMsg = 0 Then Exit Sub
    
    msg = StringFromPointer(lpMsg)
    'Debug.Print msg
    
    Select Case t
        Case cb_StringReturn:
                LastStringReturn = msg
                
        Case cb_output:
                With Form1.txtOut
                    .Text = .Text & Replace(msg, vbLf, vbCrLf)
                    .SelStart = Len(.Text)
                End With
                
        Case cb_error:
                Form1.List1.AddItem "error: " & msg
    End Select
    
End Sub


Public Function VbLineInput(ByVal buf As Long, ByVal ctx As Long) As Long
'    Dim b() As Byte
'    Dim retVal As String
'    VbLineInput = 0 'return value default..
'
'    Dim text As String
'    Dim def As String
'
'    text = StringFromPointer(buf)
'    def = GetArgAsString(ctx, 1)
'
'    retVal = InputBox(text, "Script Basic Line Input", def)
'
'    If Len(retVal) = 0 Then
'        DukOp opd_PushUndef, ctx
'        Exit Function
'    Else
'        DukOp opd_PushStr, ctx, 0, retVal
'    End If
        
  
End Function

Function StringFromPointer(buf As Long) As String
    Dim sz As Long
    Dim tmp As String
    Dim b() As Byte
    
    If buf = 0 Then Exit Function
       
    sz = lstrlen(buf)
    If sz = 0 Then Exit Function
    
    ReDim b(sz)
    CopyMemory b(0), ByVal buf, sz
    tmp = StrConv(b, vbUnicode)
    If Right(tmp, 1) = Chr(0) Then tmp = Left(tmp, Len(tmp) - 1)
    
    StringFromPointer = tmp
 
End Function

Sub dbg(prefix As String, ParamArray args())
    Dim a, tmp As String
    
    tmp = prefix
    
    For Each a In args
        If IsNumeric(a) Then
            tmp = tmp & Hex(a) & ", "
        ElseIf IsObject(a) Then
            tmp = tmp & "Obj: " & TypeName(a) & ", "
        Else
            tmp = tmp & a & ", "
        End If
    Next
    
    Form1.List1.AddItem tmp
    Debug.Print tmp
    
End Sub

Function GetParentFolder(path) As String
    On Error Resume Next
    Dim tmp() As String, ub
    If Len(path) = 0 Then Exit Function
    tmp = Split(path, "\")
    ub = tmp(UBound(tmp))
    GetParentFolder = Replace(Join(tmp, "\"), "\" & ub, "")
End Function

Sub push(ary, value) 'this modifies parent ary object
    On Error GoTo init
    Dim x
    x = UBound(ary) '<-throws Error If Not initalized
    ReDim Preserve ary(UBound(ary) + 1)
    ary(UBound(ary)) = value
    Exit Sub
init:     ReDim ary(0): ary(0) = value
End Sub



Function IsIde() As Boolean
' Brad Martinez  http://www.mvps.org/ccrp
    On Error GoTo out
    Debug.Print 1 / 0
out: IsIde = Err
End Function


Function AryIsEmpty(ary) As Boolean
  On Error GoTo oops
    Dim i
    i = UBound(ary)  '<- throws error if not initalized
    AryIsEmpty = False
  Exit Function
oops: AryIsEmpty = True
End Function

Function KeyExistsInCollection(c As Collection, val As String) As Boolean
    On Error Resume Next
    Dim t
    t = c(val)
    If Err.Number = 0 Then
        KeyExistsInCollection = True
        Exit Function
    Else
        Err.Clear
        Set t = c(val) 'maybe its an object collection?
        KeyExistsInCollection = (Err.Number = 0)
    End If
End Function

Function c2s(c As Collection) As String
    Dim x, y
    If c.Count = 0 Then Exit Function
    For Each x In c
        y = y & x & ", "
    Next
    y = Mid(y, 1, Len(y) - 2)
    c2s = y
End Function

Function FolderExists(ByVal path As String) As Boolean
  On Error GoTo hell
  Dim tmp As String
  tmp = path & "\"
  If Len(tmp) = 1 Then Exit Function
  If Dir(tmp, vbDirectory) <> "" Then FolderExists = True
  Exit Function
hell:
    FolderExists = False
End Function

Function FileExists(ByVal path As String) As Boolean
  On Error GoTo hell
    
  If Len(path) = 0 Then Exit Function
  If Right(path, 1) = "\" Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
  
  Exit Function
hell: FileExists = False
End Function

Function ReadFile(filename) As Variant
  Dim f As Long
  Dim temp As Variant
  f = FreeFile
  temp = ""
   Open filename For Binary As #f        ' Open file.(can be text or image)
     temp = Input(FileLen(filename), #f) ' Get entire Files data
   Close #f
   ReadFile = temp
End Function

Sub WriteFile(path, it)
    Dim f As Long
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
End Sub

Function AnyOfTheseInstr(sIn, sCmp) As Boolean
    Dim tmp() As String, i As Integer
    tmp() = Split(sCmp, ",")
    For i = 0 To UBound(tmp)
        tmp(i) = Trim(tmp(i))
        If Len(tmp(i)) > 0 And InStr(1, sIn, tmp(i), vbTextCompare) > 0 Then
            AnyOfTheseInstr = True
            Exit Function
        End If
    Next
End Function
